# -*- coding: utf-8 -*-
#import scikits.bvp_sp.solver
#from scipy.optimize import minimize
import numpy
from math import sin, cos, sqrt 
from opt_params import par 
 
def uopt(zz):
    F_car = (0.5*(-par.C_W*par.M_car*zz[0]*zz[5] - zz[5]*zz[6] +
    zz[5]*zz[8]*sin(zz[4]) +
    zz[7]*cos(zz[4]))/(par.C_F1*par.M_car*zz[5]))
    F_load = (par.L_0*par.M_load*par.g/par.T_f - par.L_f*par.M_load*par.g/par.T_f +
    par.M_load*par.g + 0.5*par.C_W*zz[2]/par.C_F2 +
    0.5*zz[8]/(par.C_F2*par.M_load) -
    0.5*zz[6]*sin(zz[4])/(par.C_F2*par.M_car) +
    0.5*zz[8]*sin(zz[4])**2/(par.C_F2*par.M_car) +
    0.25*zz[7]*sin(2.0*zz[4])/(par.C_F2*par.M_car*zz[5]))
    return [F_car, F_load]
 
def v_kuorma(zz):
    v_kuorma = (sqrt((zz[1]*zz[5]*sin(zz[4]) - zz[2]*cos(zz[4]))**2 + (zz[0] +
    zz[1]*zz[5]*cos(zz[4]) + zz[2]*sin(zz[4]))**2))
    return v_kuorma
 
# Muuttujien derivaatat
def odefun(t,zz):
    [F_car, F_load] = uopt(zz)
    dzdt = [ (-2.0*par.C_F1*par.C_F2*par.M_car*par.M_load*par.T_f*zz[5]*(par.cfr_car*zz[0]
    + par.cfr_kela*zz[2]*sin(zz[4])) +
    par.C_F1*(par.C_F2*par.M_car*par.M_load**2*par.T_f*par.g*zz[5] +
    par.C_F2*par.M_car*par.M_load**2*par.g*zz[5]*(par.L_0 - par.L_f) +
    0.5*par.C_W*par.M_car*par.M_load*par.T_f*zz[2]*zz[5] +
    0.5*par.M_car*par.T_f*zz[5]*zz[8] +
    0.5*par.M_load*par.T_f*zz[5]*(-zz[6] +
    zz[8]*sin(zz[4]))*sin(zz[4]) +
    0.25*par.M_load*par.T_f*zz[7]*sin(2.0*zz[4]))*sin(zz[4]) -
    0.5*par.C_F2*par.M_load*par.T_f*(par.C_W*par.M_car*zz[0]*zz[5] +
    zz[5]*zz[6] - zz[5]*zz[8]*sin(zz[4]) -
    zz[7]*cos(zz[4])))/(par.C_F1*par.C_F2*par.M_car**2*par.M_load*par.T_f*zz[5]), (-par.C_F1*par.C_F2*par.M_car*par.T_f*zz[5]*(par.M_car*par.M_load*par.g*sin(zz[4])
    + 2.0*par.M_car*par.M_load*zz[1]*zz[2] +
    2.0*par.M_car*par.cfr_load*zz[0]*cos(zz[4]) +
    2.0*par.M_car*par.cfr_load*zz[1]*zz[5] -
    2.0*par.M_load*par.cfr_car*zz[0]*cos(zz[4]) -
    par.M_load*par.cfr_kela*zz[2]*sin(2.0*zz[4])) -
    0.5*par.C_F1*(par.C_F2*par.M_car*par.M_load**2*par.T_f*par.g*zz[5]
    + par.C_F2*par.M_car*par.M_load**2*par.g*zz[5]*(par.L_0 - par.L_f)
    + 0.5*par.C_W*par.M_car*par.M_load*par.T_f*zz[2]*zz[5] +
    0.5*par.M_car*par.T_f*zz[5]*zz[8] +
    0.5*par.M_load*par.T_f*zz[5]*(-zz[6] +
    zz[8]*sin(zz[4]))*sin(zz[4]) +
    0.25*par.M_load*par.T_f*zz[7]*sin(2.0*zz[4]))*sin(2.0*zz[4]) +
    0.5*par.C_F2*par.M_load*par.T_f*(par.C_W*par.M_car*zz[0]*zz[5] +
    zz[5]*zz[6] - zz[5]*zz[8]*sin(zz[4]) -
    zz[7]*cos(zz[4]))*cos(zz[4]))/(par.C_F1*par.C_F2*par.M_car**2*par.M_load*par.T_f*zz[5]**2), -par.L_0*par.g/par.T_f -
    par.L_0*par.M_load*par.g*sin(zz[4])**2/(par.M_car*par.T_f) +
    par.L_f*par.g/par.T_f +
    par.L_f*par.M_load*par.g*sin(zz[4])**2/(par.M_car*par.T_f) +
    par.g*cos(zz[4]) - par.g + zz[1]**2*zz[5] +
    2.0*par.cfr_kela*zz[2]/par.M_load -
    2.0*par.cfr_load*zz[0]*sin(zz[4])/par.M_load -
    2.0*par.cfr_load*zz[2]/par.M_load -
    par.M_load*par.g*sin(zz[4])**2/par.M_car +
    2.0*par.cfr_car*zz[0]*sin(zz[4])/par.M_car +
    2.0*par.cfr_kela*zz[2]*sin(zz[4])**2/par.M_car -
    0.5*par.C_W*zz[2]/(par.C_F2*par.M_load) -
    0.5*par.C_W*zz[2]*sin(zz[4])**2/(par.C_F2*par.M_car) -
    0.5*zz[8]/(par.C_F2*par.M_load**2) +
    0.5*zz[6]*sin(zz[4])/(par.C_F2*par.M_car*par.M_load) -
    1.0*zz[8]*sin(zz[4])**2/(par.C_F2*par.M_car*par.M_load) -
    0.25*zz[7]*sin(2.0*zz[4])/(par.C_F2*par.M_car*par.M_load*zz[5]) +
    0.5*zz[6]*sin(zz[4])**3/(par.C_F2*par.M_car**2) -
    0.5*zz[8]*sin(zz[4])**4/(par.C_F2*par.M_car**2) -
    0.25*zz[7]*sin(zz[4])**2*sin(2.0*zz[4])/(par.C_F2*par.M_car**2*zz[5])
    + 0.5*par.C_W*zz[0]*sin(zz[4])/(par.C_F1*par.M_car) +
    0.5*zz[6]*sin(zz[4])/(par.C_F1*par.M_car**2) -
    0.5*zz[8]*sin(zz[4])**2/(par.C_F1*par.M_car**2) -
    0.5*zz[7]*sin(zz[4])*cos(zz[4])/(par.C_F1*par.M_car**2*zz[5]), zz[0], zz[1], zz[2], (2.0*par.C_F1*(par.M_load*par.cfr_car*zz[5]*zz[6] +
    zz[5]*zz[8]*(par.M_car*par.cfr_load -
    par.M_load*par.cfr_car)*sin(zz[4]) + zz[7]*(par.M_car*par.cfr_load
    - par.M_load*par.cfr_car)*cos(zz[4])) -
    par.M_load*(par.C_F1*par.M_car*zz[5]*zz[9] -
    0.5*par.C_W*(par.C_W*par.M_car*zz[0]*zz[5] + zz[5]*zz[6] -
    zz[5]*zz[8]*sin(zz[4]) -
    zz[7]*cos(zz[4]))))/(par.C_F1*par.M_car*par.M_load*zz[5]), -2*zz[1]*zz[5]*zz[8] - zz[10] + 2.0*zz[2]*zz[7]/zz[5] +
    2.0*par.cfr_load*zz[7]/par.M_load, par.C_W*par.L_0*par.M_load*par.g/par.T_f -
    par.C_W*par.L_f*par.M_load*par.g/par.T_f +
    par.C_W*par.M_load*par.g + 2.0*zz[1]*zz[7]/zz[5] - zz[11] -
    2.0*par.cfr_kela*zz[8]/par.M_load +
    2.0*par.cfr_load*zz[8]/par.M_load +
    2.0*par.cfr_kela*zz[6]*sin(zz[4])/par.M_car -
    2.0*par.cfr_kela*zz[8]*sin(zz[4])**2/par.M_car -
    par.cfr_kela*zz[7]*sin(2.0*zz[4])/(par.M_car*zz[5]) +
    0.5*par.C_W**2*zz[2]/par.C_F2 +
    0.5*par.C_W*zz[8]/(par.C_F2*par.M_load) -
    0.5*par.C_W*zz[6]*sin(zz[4])/(par.C_F2*par.M_car) +
    0.5*par.C_W*zz[8]*sin(zz[4])**2/(par.C_F2*par.M_car) +
    0.25*par.C_W*zz[7]*sin(2.0*zz[4])/(par.C_F2*par.M_car*zz[5]), 0, (-par.C_F1*zz[5]*zz[6]*(par.C_F2*par.M_car*par.M_load**2*par.g*zz[5]*(par.L_0
    - par.L_f) +
    par.C_F2*par.M_car*par.M_load*par.T_f*zz[5]*(par.M_load*par.g -
    2.0*par.cfr_kela*zz[2]) +
    0.5*par.C_W*par.M_car*par.M_load*par.T_f*zz[2]*zz[5] +
    0.5*par.M_car*par.T_f*zz[5]*zz[8] +
    0.5*par.M_load*par.T_f*zz[5]*(-zz[6] +
    zz[8]*sin(zz[4]))*sin(zz[4]) +
    0.25*par.M_load*par.T_f*zz[7]*sin(2.0*zz[4]))*cos(zz[4]) +
    zz[5]*zz[8]*(par.C_F1*par.C_F2*par.M_car**2*par.T_f*zz[5]*(par.M_load*par.g*sin(zz[4])
    + 2.0*par.cfr_load*zz[0]*cos(zz[4])) -
    (par.C_F1*par.C_F2*par.M_car*par.M_load*par.T_f*zz[5]*(2.0*par.cfr_car*zz[0]
    + 4.0*par.cfr_kela*zz[2]*sin(zz[4])) -
    2*par.C_F1*(par.C_F2*par.M_car*par.M_load**2*par.T_f*par.g*zz[5] +
    par.C_F2*par.M_car*par.M_load**2*par.g*zz[5]*(par.L_0 - par.L_f) +
    0.5*par.C_W*par.M_car*par.M_load*par.T_f*zz[2]*zz[5] +
    0.5*par.M_car*par.T_f*zz[5]*zz[8] +
    0.5*par.M_load*par.T_f*zz[5]*(-zz[6] +
    zz[8]*sin(zz[4]))*sin(zz[4]) +
    0.25*par.M_load*par.T_f*zz[7]*sin(2.0*zz[4]))*sin(zz[4]) +
    0.5*par.C_F2*par.M_load*par.T_f*(par.C_W*par.M_car*zz[0]*zz[5] +
    zz[5]*zz[6] - zz[5]*zz[8]*sin(zz[4]) -
    zz[7]*cos(zz[4])))*cos(zz[4])) +
    zz[7]*(par.C_F1*par.C_F2*par.M_car*par.T_f*zz[5]*(par.M_car*par.M_load*par.g*cos(zz[4])
    - 2.0*par.M_car*par.cfr_load*zz[0]*sin(zz[4]) +
    2.0*par.M_load*par.cfr_car*zz[0]*sin(zz[4]) -
    2.0*par.M_load*par.cfr_kela*zz[2]*cos(2.0*zz[4])) +
    1.0*par.C_F1*(par.C_F2*par.M_car*par.M_load**2*par.T_f*par.g*zz[5]
    + par.C_F2*par.M_car*par.M_load**2*par.g*zz[5]*(par.L_0 - par.L_f)
    + 0.5*par.C_W*par.M_car*par.M_load*par.T_f*zz[2]*zz[5] +
    0.5*par.M_car*par.T_f*zz[5]*zz[8] +
    0.5*par.M_load*par.T_f*zz[5]*(-zz[6] +
    zz[8]*sin(zz[4]))*sin(zz[4]) +
    0.25*par.M_load*par.T_f*zz[7]*sin(2.0*zz[4]))*cos(2.0*zz[4]) -
    0.5*par.C_F2*par.M_load*par.T_f*(-par.C_W*par.M_car*zz[0]*zz[5] -
    zz[5]*zz[6] + zz[5]*zz[8]*sin(zz[4]) +
    zz[7]*cos(zz[4]))*sin(zz[4])))/(par.C_F1*par.C_F2*par.M_car**2*par.M_load*par.T_f*zz[5]**2), (-1.0*par.C_F1*par.C_F2*par.M_car*par.T_f*zz[5]*(1.0*par.M_car*par.M_load*par.g*zz[7]*sin(zz[4])
    + 1.0*par.M_car*par.M_load*zz[1]**2*zz[5]**2*zz[8] +
    2.0*par.M_car*par.M_load*zz[1]*zz[2]*zz[7] +
    2.0*par.M_car*par.cfr_load*zz[0]*zz[7]*cos(zz[4]) -
    2.0*par.M_load*par.cfr_car*zz[0]*zz[7]*cos(zz[4]) -
    1.0*par.M_load*par.cfr_kela*zz[2]*zz[7]*sin(2.0*zz[4])) -
    0.5*par.C_F1*zz[7]*(par.C_F2*par.M_car*par.M_load**2*par.T_f*par.g*zz[5]
    + par.C_F2*par.M_car*par.M_load**2*par.g*zz[5]*(par.L_0 - par.L_f)
    + 0.5*par.C_W*par.M_car*par.M_load*par.T_f*zz[2]*zz[5] +
    0.5*par.M_car*par.T_f*zz[5]*zz[8] +
    0.5*par.M_load*par.T_f*zz[5]*(-zz[6] +
    zz[8]*sin(zz[4]))*sin(zz[4]) +
    0.25*par.M_load*par.T_f*zz[7]*sin(2.0*zz[4]))*sin(2.0*zz[4]) +
    0.5*par.C_F2*par.M_load*par.T_f*zz[7]*(par.C_W*par.M_car*zz[0]*zz[5]
    + zz[5]*zz[6] - zz[5]*zz[8]*sin(zz[4]) -
    zz[7]*cos(zz[4]))*cos(zz[4]))/(par.C_F1*par.C_F2*par.M_car**2*par.M_load*par.T_f*zz[5]**3)]
    return numpy.array(dzdt)
 
# Reuna-arvot. Palauttaa poikkeaman halutusta.
def bcfun(zz0,zz):
    yy_0 = [0.0,0.0,0.0,par.x0_car,0.0,par.L_0]
    yy_f = [0.0,0.0,0.0,par.xf_car,0.0,par.L_f]

    bc0 = [zz0[i]-yy_0[i] for i in range(0,2*par.sysdim)]

    bcf = [zz[i]-yy_f[i] for i in range(0,2*par.sysdim)]
    return(numpy.array(bc0),numpy.array(bcf))
 
# Alkuarvaus ajan funktiona
def init_guess(t):
    guess1 = [(-par.x0_car + par.xf_car)/par.T_f,0.0,(-par.L_0 + par.L_f)/par.T_f,par.x0_car + t*(-par.x0_car + par.xf_car)/par.T_f,0.0,par.L_0 + t*(-par.L_0 + par.L_f)/par.T_f,1.0,-1.0,1.0,-1.0,-1.0,1.0]
    return guess1
 
def xy_load(zz):
    xy_load = [ zz[3] + zz[5]*sin(zz[4]), -zz[5]*cos(zz[4])]
    return xy_load 
 
